ac = {
  init: function () {
    if (typeof (Storage) !== 'undefined') {
      ac.renderPresets();
    } else {
      $('#ac_preset_container').html('<i>Presets not available on your browser :(</i>');
    }
  },
  savePreset: function () {
    var name = prompt('New preset name?');
    if (name == null)
    return;
    var presets = ac.getPresets();
    presets.push({
      name: name,
      value: $('#compconfig').val()
    });
    ac.savePresets(presets);
    ac.renderPresets();
    $('#ac_preset_list').prop('selectedIndex', presets.length);
  },
  deletePreset: function () {
    var id = ac.getSelectedPresetID();
    if (id < 0)
    return;
    $('#compconfig').text('');
    var presets = ac.getPresets();
    presets.splice(id, 1);
    ac.savePresets(presets);
    ac.renderPresets();
  },
  getPresets: function () {
    var presets = localStorage.ac_presets;
    if (presets != undefined) {
      try {
        presets = JSON.parse(presets);
      } catch (err) {
        presets = undefined;
      }
    }
    if (presets == undefined || !$.isArray(presets)) {
      presets = [
      ];
      ac.savePresets(presets);
    }
    return presets;
  },
  renderPresets: function () {
    $('#ac_preset_list').change(function () {
    });
    $('#ac_preset_list').empty();
    var presets = ac.getPresets();
    if (presets.length > 0) {
      $('#ac_preset_list').prop('disabled', false);
      $('#ac_preset_list').append($('<option value="none">Select...</option>'));
      for (var i = 0; i < presets.length; i++) {
        $('#ac_preset_list').append($('<option value="' + i + '">' + presets[i].name + '</option>'));
      }
      $('#ac_preset_list').change(function () {
        var id = ac.getSelectedPresetID();
        if (id >= 0) {
          $('#ac_linkdelete').show();
          ac.activatePreset(id);
        } else {
          $('#ac_linkdelete').hide();
        }
      });
      $('#ac_preset_list').prop('selectedIndex', 0);
    } else {
      $('#ac_linkdelete').hide();
      $('#ac_preset_list').append($('<option>None</option>'));
      $('#ac_preset_list').prop('disabled', true);
    }
  },
  getSelectedPresetID: function () {
    var id = $('#ac_preset_list').val();
    if (id == 'none')
    return - 1;
    return parseInt(id);
  },
  savePresets: function (presets) {
    localStorage.ac_presets = JSON.stringify(presets);
  },
  activatePreset: function (id) {
    var presetData = ac.getPresets() [id].value;
    $('#compconfig').val(presetData);
  }
}
