dropFilters();

var svace_classification={};
var svace_severity={};
var svace_action={};
var svace_TS={};
var svaceAttributesFetched = false;

function fetchAttributesValues() {
	if (svaceAttributesFetched)
		return true;
	svace_classification={};
	svace_severity={};
	svace_action={};
	svace_TS={};
	var classificationSuccess = false;
	$.ajax( {
		url:'/history/api?act=get_value_filter&field=status',
		dataType: 'json',
		cache: false,
		async: false,
		success: function (data, textStatus) {
			//data is already json
			if (data.status == "OK") {
				classificationSuccess = true;
			    $('#WarnClassification').html('');
			    $('#classificationFilters').html('');
				for (var i=0; i<data.classification.length; i++) {
					name = data.classification[i].name;
					id = data.classification[i].id;
				    $('#WarnClassification').append($("<option></option>").attr("value", id).text(name));
				    svace_classification[id]=name;
				    $('#classificationFilters').append($("<input type=checkbox></input>").attr("id", 'filter_classification_'+id).prop("checked", true));
				    $('#classificationFilters').append(document.createTextNode(name))
				    $('#classificationFilters').append($("<br />"));
				}
			}
		},
		error: ajaxError
	});
	var severitySuccess = false;
	$.ajax( {
		url:'/history/api?act=get_value_filter&field=severity',
		dataType: 'json',
		cache: false,
		async: false,
		success: function (data, textStatus) {
			//data is already json
			if (data.status == "OK") {
				severitySuccess = true;
			    $('#WarnSeverity').html('');
			    $('#severityFilters').html('');
				for (var i=0; i<data.severity.length; i++) {
					name = data.severity[i].name;
					id = data.severity[i].id;
				    $('#WarnSeverity').append($("<option></option>").attr("value", id).text(name));
				    svace_severity[id]=name;
				    $('#severityFilters').append($("<input type=checkbox></input>").attr("id", 'filter_severity_'+id).prop("checked", true));
				    $('#severityFilters').append(document.createTextNode(name))
				    $('#severityFilters').append($("<br />"));
				}
			}
		},
		error: ajaxError
	});

	var actionSuccess = false;
	$.ajax( {
		url:'/history/api?act=get_value_filter&field=action',
		dataType: 'json',
		cache: false,
		async: false,
		success: function (data, textStatus) {
			//data is already json
			if (data.status == "OK") {
				actionSuccess = true;
			    $('#WarnAction').html('');
			    $('#actionFilters').html('');
				for (var i=0; i<data.action.length; i++) {
					name = data.action[i].name;
					id = data.action[i].id;
				    $('#WarnAction').append($("<option></option>").attr("value", id).text(name));
				    svace_action[id]=name;
				    $('#actionFilters').append($("<input type=checkbox></input>").attr("id", 'filter_action_'+id).prop("checked", true));
				    $('#actionFilters').append(document.createTextNode(name))
				    $('#actionFilters').append($("<br />"));
				}
			}
		},
		error: ajaxError
	});
	var TSSuccess = false;
	$.ajax( {
		url:'/history/api?act=get_value_filter&field=triaged',
		dataType: 'json',
		cache: false,
		async: false,
		success: function (data, textStatus) {
			//data is already json
			if (data.status == "OK") {
				TSSuccess = true;
				$('#TSFilters').html('');
				for (var i=0; i<data.triaged_status.length; i++) {
					name = data.triaged_status[i].name;
					id = data.triaged_status[i].id;
					svace_TS[id]=data.triaged_status[i];
					var enabled = (data.triaged_status[i].enabled==true);
					$('#TSFilters').append($("<input type=checkbox></input>").attr("id", 'filter_TS_'+id).prop("checked", enabled));
					$('#TSFilters').append(document.createTextNode(name))
					$('#TSFilters').append($("<br />"));
				}
			}
		},
		error: ajaxError
	});
	fetchTypesValues(true);
	svaceWarningsFilters = new Object();
	svaceWarningsFilters._stub='%'; //otherwise i get jq exception on request if no filters are present
	svaceAttributesFetched = classificationSuccess&&actionSuccess&&severitySuccess&&TSSuccess;
	return svaceAttributesFetched;
}

function svaceApplyFilters(){

	{
		classification='';
		filterClass = false;
 		for (var idx in Object.keys(svace_classification)){
 			if ($('#filter_classification_'+idx).prop('checked')){
 				classification+=','+idx;
 			} else {
 				filterClass = true;
 			}
 		}
 		if (classification.length>1)
 			classification = classification.substring(1);
 	
 		if (!filterClass)
 			delete svaceWarningsFilters.classification;
 		else 
 			svaceWarningsFilters.classification = classification;
	}
	
	{
		action='';
		filterClass = false;
 		for (var idx in Object.keys(svace_action)){
 			if ($('#filter_action_'+idx).prop('checked')){
 				action+=','+idx;
 			} else {
 				filterClass = true;
 			}
 		}
 		if (action.length>1)
 			action = action.substring(1);
 	
 		if (!filterClass)
 			delete svaceWarningsFilters.action;
 		else 
 			svaceWarningsFilters.action = action;
	}
	
	{
		severity='';
		filterClass = false;
 		for (var idx in Object.keys(svace_severity)){
 			if ($('#filter_severity_'+idx).prop('checked')){
 				severity+=','+idx;
 			} else {
 				filterClass = true;
 			}
 		}
 		if (severity.length>1)
 			severity = severity.substring(1);
 	
 		if (!filterClass)
 			delete svaceWarningsFilters.severity;
 		else 
 			svaceWarningsFilters.severity = severity;
	}
	
	{
		var TS='';
		var filterClass = false;
		$.each(svace_TS, function(idx, value){
			checkBoxSelected = $('#filter_TS_'+idx).prop('checked');
			defaultSelection = svace_TS[idx].enabled;
 			if (checkBoxSelected){
 				TS+=','+idx;
 			}
 			if (checkBoxSelected!=defaultSelection)
 				filterClass = true;
 		});
 		if (TS.length>1)
 			TS = TS.substring(1);
 	
 		if (!filterClass)
 			delete svaceWarningsFilters.status;
 		else 
 			svaceWarningsFilters.status = TS;
	}
	
	{
		var checkers='';
		var filterCheckers = false;
		var filterCheckersBySeverity = false;
		
		sevFilterVal = $("#CheckerSevFilter").val();
		filteredCheckers=[];
		if ((sevFilterVal!=undefined)&&(sevFilterVal!='*')){
			filterCheckers = true;
			filterCheckersBySeverity = true;
			checkersWithSeverity = checkersBySeverity[sevFilterVal];
			for (i=0; i<checkersWithSeverity.length;i++){
				filteredCheckers.push(checkersWithSeverity[i].checker_id);
			}
		}
		
		relFilterVal = $("#CheckerRelFilter").val();
		if ((relFilterVal!=undefined)&&(relFilterVal!='*')){
			filterCheckers = true;
			checkersWithReliability = checkersByReliability[relFilterVal];
			newFilteredCheckers = [];
			for (i=0; i<checkersWithReliability.length;i++){
				chID = checkersWithReliability[i].checker_id;
				if ((!filterCheckersBySeverity)||(filteredCheckers.indexOf(chID)!=-1))
					newFilteredCheckers.push(chID);
			}
			filteredCheckers = newFilteredCheckers;
		}
		
 		if (!filterCheckers)
 			delete svaceWarningsFilters.checker;
 		else 
 			svaceWarningsFilters.checker = filteredCheckers.join(",");
	}
	
	{
		var files=generateContainerFileList('fileFilters');
 		if (files.length>1)
 			svaceWarningsFilters.files = files.substring(1);
 		else
 			delete svaceWarningsFilters.files;
	}
	
	$('#filtersList').toggle();
	drop(SVACE_CLEANUP_FILTERS);	
	updateWarnings();
}

function generateContainerFileList(containerID){
	var firstLevelChildren = $('#'+containerID+'> input:checkbox');
	var result = "";
	firstLevelChildren.each(function(){
		checkbox=$(this);
		if (checkbox.attr("svace_type")=="d"){
			if (checkbox.prop('checked')){
				result+=","+directoriesIDs[checkbox.attr("id").substring(6)];
			} else {
				result+=generateContainerFileList('dir_'+checkbox.attr("id").substring(6));
			}
		} else if (checkbox.attr("svace_type")=="f") {
			if (checkbox.prop('checked')){
				result+=","+checkbox.attr("id").substring(6);
			}
		}
		});
	return result;
}

// The list of all possible warning types
var all_svace_checkers=[];
// The list of warning types for the issues that should be displayed for
// the current project
var svace_checkers=[];
// If fetchAll is true, get the list of all possible warning types, otherwise
// get the list of warning types for the issues that will be fetched for the
// current project
function fetchTypesValues(fetchAll, proj) {
	var typesSuccess = false;

	$.ajax( {
		url:'/history/api?act=get_value_filter&field=warn_types'+(fetchAll?'':(getBranchParameter(proj)+getProjectParameter(proj)+('&snapshot_id='+makeSnapshotIDParm(proj)))),
		dataType: 'json',
		cache: false,
		async: false,
		success: function (data, textStatus) {
			//data is already json
			if (data.status == "OK") {
				typesSuccess = true;
				groups = data.checker_groups;
				target=[];
				for (i=0; i<groups.length;i++){
					group=groups[i];
					for (k=0; k<group.checkers.length;k++){
						checker=group.checkers[k];
						target[checker.checker_id] = checker;
						all_svace_checkers[checker.checker_id] = checker;
					}
				}
				if (fetchAll) {
					renderCheckerCheckboxes(target);
				} else {
					svace_checkers=target;
				}
			}
		},
		error: function (data, textstatus, error) {
			setError("Error for project " + proj.project_name + "(id " + proj.project_id + ")");
			ajaxError(data, textstatus, error);
		}
	});
	return typesSuccess;
}

checkersBySeverity={};
checkersByReliability={};
function renderCheckerCheckboxes(allCheckers){
	checkersBySeverity={};
	checkersByReliability={};
	for (i=0; i<groups.length;i++){
		group=groups[i];
		for (k=0; k<group.checkers.length;k++){
			checker=group.checkers[k];
			
			sevCollector = checkersBySeverity[checker.checker_severity];
			if (sevCollector==undefined){
				sevCollector=[];
				checkersBySeverity[checker.checker_severity] = sevCollector;
			}
			sevCollector.push(checker);

			relCollector = checkersByReliability[checker.checker_reliability];
			if (relCollector==undefined){
				relCollector=[];
				checkersByReliability[checker.checker_reliability] = relCollector;
			}
			relCollector.push(checker);
		
		}
	}
	$("#CheckerFilters").html("Severity: <select id='CheckerSevFilter'></select><br/>Reliability: <select id='CheckerRelFilter'></select>");
	filter = $("#CheckerSevFilter");
	filter.append($("<option></option>").attr("value", '*').text("Any"));
	for (var key in checkersBySeverity) {
		if (checkersBySeverity.hasOwnProperty(key)) {
			filter.append($("<option></option>").attr("value", key).text(key));
		}
	}
	filter = $("#CheckerRelFilter");
	filter.append($("<option></option>").attr("value", '*').text("Any"));
	for (var key in checkersByReliability) {
		if (checkersByReliability.hasOwnProperty(key)) {
			filter.append($("<option></option>").attr("value", key).text(key));
		}
	}
}

function getCheckerName(id){
	result=all_svace_checkers[id];
	if (result != undefined) 
		return result.checker_name;

	result=svace_checkers[id];
	if (result != undefined) 
		return result.checker_name;
	
	return 'Checker_'+id;
}

function getCheckerDesc(id){
	result=all_svace_checkers[id];
	if (result == undefined)
		return '';
	return '\nSeverity: '+result.checker_severity+'\nReliability: '+result.checker_reliability;
}

function dropFilters(){
	svaceWarningsFilters = new Object();
	svaceWarningsFilters._stub='%'; //otherwise i get jq exception on request if no filters are present
}
