var gotWarnings=false;
//This variable contains large set of warnings (warnings from a project; warnings from
//a set of objects; server-side-filtered set of warnings). You may perform client-side
//filtering of these warnings. This set is NOT the set of warning that is currently
//displayed.
//Map [Warning ID => Warning]
var WarningObjectsWrap={WarningObjects:{}};
//Due to some algorithms we previously tried not to change link to this variable,
//so cleaning it up was an extremely expensive operation. We now do use a wrapper var
//instead and preserve link to a wrapper; cleaning data itself can be done by a simple
//wrapper field assignment. And old war is now commented out.
//var WarningObjects={};

/**
 * THESE FOUR VARIABLES CONTAINS DATA ABOUT DISPLAYED WARNINGS
 * Please use renderWarningGroups() to display warnings (and do not write your own renderer)
 * to make future structure changes compatible
 */
//this variable contains all warnings which are currently displayed.
//It is cleaned up when and only when warning list is cleaned up.
//When new warnings pack is transferred into renderWarningsGroups,
//the rendered warnings are also added into this variable. 
var DisplayedWarnings={};

//This variable contains all _displayed_ warnings sorted by warning classes (aka checkers).
//This is done for rendering actual warnings only when they are needed:
//when their checker group is expanded.
//
//It is not recommended to store a reference to this element
//
//Map [Checker id => array of warnings]
var DisplayedWarningsByChecker={};
var DisplayedWarningsCheckersData={};
//to mark lines with warnings on the source code..
var WarningsByFiles={};

// A simple lock used in fetchWarnings to ensure that only one warning fetching
// process runs at a time.
// It's set to true when fetchWarnings is fetching new warnings, should be
// false otherwise.
// (Note that ajaxError and error in fetchTypesValues also reset it to false.)
var fetching = false;

var timeout = null;

function clearDisplayedWarnings(){
	$('#warningsList').html("");
	//previously we used 'clearObject' here, but it was TOO slow!
	DisplayedWarnings={};
	DisplayedWarningsByChecker={};
	DisplayedWarningsCheckersData={};
	WarningsByFiles={};
}

/*
 * Update list of warning for showing and show it
 */
function updateWarnings() {
	if (timeout!=null)
		clearTimeout(timeout);
	//first, let's check we ever have session information set
	if (($.cookie('sidset')!=1)) {
		forceLogin("Login required");
		return;
	}
	
	var hasProject;
	if (COMPARE_MODE){
		hasProject=(COMPARE_PROJECTS.project_1!=null)&&(COMPARE_PROJECTS.project_2!=null);
	} else if (loadFromAllProjects) {
		hasProject = (LFAcontroller!=null)
	} else {
		hasProject = (currentSvaceProject!=null);
	}
	
	if (hasProject){
		try {
			if (!gotWarnings) {
				fetchWarningsUniversal();
			}
			fetchUpdatesUniversal();
		} catch (err) {
			setError(err);
		}
	}
	
	// Only update once we've selected a project
	timeout = setTimeout(updateWarnings, 3000);
}

function fetchWarningsUniversal(){
	if (fetching)
		return;
	fetching = true;

	$('#warningsLoading').show();
	$('#warningsLoadingCounter').text("");
	if (COMPARE_MODE){
		fetchCompareData();
	} else if (loadFromAllProjects) {
		fetchWarningsLFA();
	} else {
		fetchWarnings();
	}
}

function fetchUpdatesUniversal(){
	if (!gotWarnings) {
		fetchWarningsUniversal();
		return;
	}
	
	//TODO: first, make request for updated projects (it is lighteight).
	//Only fetch updates for updated projects.
	//Already implemented for LFA.
	if (COMPARE_MODE){
		fetchUpdatesImpl(COMPARE_PROJECTS.project_1);
		fetchUpdatesImpl(COMPARE_PROJECTS.project_2);
	} else if (loadFromAllProjects) {
		updateWarningsLFA();
	} else {
		fetchUpdatesImpl(currentSvaceProject);
	}}

function rememberWarning(Warning, lWarningObjects){
	lWarningObjects[Warning.warning_id] = Warning;
	DisplayedWarnings[Warning.warning_id] = Warning;

	var classcollector = DisplayedWarningsByChecker[Warning.checker_id];
	if (classcollector==null){
		classcollector = [];
		DisplayedWarningsByChecker[Warning.checker_id]=classcollector;
		DisplayedWarningsCheckersData[Warning.checker_id]={
				_id: Warning.checker_id,
				name: getCheckerName(Warning.checker_id),
				amount: 0
		};
	}
	classcollector[classcollector.length]=Warning;
	DisplayedWarningsCheckersData[Warning.checker_id].amount++;
	
	Warning.UITraceShown=false;
	Warning.UITraceLoaded=false;
	
	locationFile = Warning.location.file_path;
	if (WarningsByFiles[locationFile]==undefined)
		WarningsByFiles[locationFile] = [];
	WarningsByFiles[locationFile].push(Warning);
}

/*
 * Sort input warnings and save it into arrays.
 * Also generate form in html for all warnings.
 */
function renderWarningGroups(Warnings, lWarningObjects, showWarnings) {
	var warnNum = Warnings.length;
	if (warnNum==0 && !loadFromAllProjects) {
		$('#warningsList').text("No warnings (check filters?)");
	}
	
	for (var i = 0; i < warnNum; i++) {
		var Warning = Warnings[i];
		
		if (showWarnings){
			getWarningGroupBox(Warning.checker_id);
		}
		counter=$('#ch_'+Warning.checker_id+'_counter');
		counter.text(parseInt(counter.text())+1);
		
		rememberWarning(Warning, lWarningObjects);
		
		if ((i%977)==0) //no frequent updates==more happy browsers. constant is magic.
			$('#warningsLoadingCounter').text(" "+currentSvaceProject.project_name+": "+i+"/"+warnNum);
	}
	resortCheckerGroups();
}

/*
 * Return element on html, which contains warnings with given classID.
 * Create the element, if it not exist. This element will not contain warnings whose IDs
 * are not elements of a key set of the 'warningsToShow' map.
 * @param 'warningsToShow' may be undefined
 */
function getWarningGroupBox(warnClassID, warningsToShow) {
	var id = "LIST_"+warnClassID;
	var a = document.getElementById(id);
	if (a==null) {
		var containerID = id+"_container";
		container = document.createElement('div');
		container.setAttribute('id', containerID);
		var list = document.getElementById('warningsList');
		
		var checkerName = getCheckerName(warnClassID);
		
		insertInIDOrder(list, container, checkerName);
		container.innerHTML =
			"<div id='"+id+"_header' class='GROUP_HEADER' title='"+checkerName+getCheckerDesc(warnClassID)+"'>"+
				checkerName+"(<div id='ch_"+warnClassID+"_counter' class='counter' style='display:inline'>0</div>) "+
				"<div id='"+id+"_expansion_status' style='display:inline'>&gt;</div>" +
			"</div>"+
		    "<div id='"+id+"' style='display:none;'></div>";
		var blockShown=false;

		// _header also affects displayWarningByIDAndClass
		var header = $('#'+id+'_header');
		header.click(function() {
			blockShown=!blockShown;
			if (blockShown) {
				if ( $('#'+id).children().length == 0 ) {
					$('#warningsLoading').show();
					var classcollection = DisplayedWarningsByChecker[warnClassID];
					if (classcollection!=null){
						classcollection = classcollection.sort(function(a,b){
							return a.ui_sortingdata.localeCompare(b.ui_sortingdata);
						});
						if (classcollection.length>0){
							var container = getWarningGroupBox(classcollection[0].checker_id);
							for (var idx=0; idx<classcollection.length; idx++){
								if (warningsToShow == undefined || (warningsToShow != undefined && classcollection[idx].warning_id in warningsToShow))
									makeWarningBox(classcollection[idx], container);
								if ((idx%977)==0) //no frequent updates==more happy browsers. constant is magic.
									$('#warningsLoadingCounter').text(" "+idx+"/"+classcollection.length);
							}
						}
					}
					$('#warningsLoadingCounter').text("");
					$('#warningsLoading').hide();
				}
				$('#'+id).show();
				$('#'+id+'_expansion_status').text("v");
			} else {
				$('#'+id).hide();
				$('#'+id+'_expansion_status').text(">");
			}
		});
		//right-click gives popup with list of warning id's in this group. This may help you to perform sampling: use these warning-id's in filter.
		addDisplayWIDsListener(header, DisplayedWarningsByChecker[warnClassID], warningsToShow);
		res = document.getElementById(id);
		return res;
	}
	return a;
}

/*
 * Generate form in html with given warning.
 * The generated box is inserted in the end of the list of warnings of it's class,
 * so you'd better call this function in the cycle on the already sorted warnings array. 
 */
function makeWarningBox(Warning, container){
	warningEntry = document.createElement('div');
	warningEntry.setAttribute('id', "Warning_"+Warning.warning_id);

	container.appendChild(warningEntry);

	var renameInfo = "";
	if(Warning.renamedPreviousVersion != undefined)
	{
	    renameInfo = "[was " + DisplayedWarningsCheckersData[Warning.renamedPreviousVersion.checker_id].name + "] ";
	}

	warningEntry.setAttribute('class',
			          "WARNING_CONTAINER"+
				  " classification_"+Warning.attributes.classification_id+
				  " severity_"+Warning.attributes.severity_id+
				  (Warning.attributes.comment==""?"":" commented"));
	warningEntry.innerHTML = "<font size='2'>" + renameInfo + escapeHTML(Warning.message)+"</font><br/>" +
			"<a href='javascript:;' id='"+Warning.warning_id+"_trace_button'>trace <div style='display:inline;' id='"+Warning.warning_id+"_trace_exp'>&gt; [" + Warning.location.short_name + "]</div></a>" +
					"<div id='"+Warning.warning_id+"_trace_data' style='display:none;'>loading...</div>" +
							"<div id='"+Warning.warning_id+"_reviewers'></div>";
	reviewers = "";
	
	fillWarningReviewers(Warning.reviewers, $('#'+Warning.warning_id+"_reviewers"));
	$('#'+Warning.warning_id+'_trace_button').click([Warning],function(warns) {
		var Warning = warns.data[0];
		Warning.UITraceShown = !Warning.UITraceShown;
		if (Warning.UITraceShown) {
			$('#'+Warning.warning_id+'_trace_data').show();
			$('#'+Warning.warning_id+'_trace_exp').text("v [" + Warning.location.short_name +"]");
		} else {
			$('#'+Warning.warning_id+'_trace_data').hide();
			$('#'+Warning.warning_id+'_trace_exp').text("> [" + Warning.location.short_name +"]");
		}
		if (!Warning.UITraceLoaded) {
			loadTraceData(Warning);
			Warning.UITraceLoaded = true;
		}
		
	});
	$('#Warning_'+Warning.warning_id).click([Warning.warning_id],displayWarning);
}

function fillWarningReviewers(reviewers, container){
	//actually I want here a picture like this:
	//      ‸
	//     / \
	//    /<o>\
	//   /_____\
	if (reviewers.length==0){
		container.text("");
		return;
	}
	reviewers.sort();
	var s = (reviewers.length==1)?" is":"s are";
	var revsText = reviewers.length+" user"+s+" currently reviewing this warning: ";
	revsText+=reviewers.join(',');
	container.text(revsText);
}

function makeSnapshotIDParm(proj) {
	return proj.ui.controller.getSnapshot();
}

/*
 * Delete all properties of project.
 * Equivalent to
 * obj = {};
 * but do not change location of object
 */
function clearObject(obj){
	for (prop in obj) {
		if (obj.hasOwnProperty(prop)) {
			delete obj[prop];
		}
	}
}

function fetchWarnings(options){
	var proj = currentSvaceProject;
	var defaultConfig={
		/**
		 * object, containing map id => warning object we should store fetched warnings into.
		 */
		container: WarningObjectsWrap,
		/**
		 * if that warning list should be cleared before fetching or appended
		 */
		clearContainer: true,
		/**
		 * if fetched warnings should be rendered in list immediately or just fetched
		 */
		displayWarnings: true,
		
		projectParam: getProjectParameter(proj),
		snapshotParam: makeSnapshotIDParm(proj),
		/**
		 * snapshot id to fetch data for
		 */
		branchParam: getBranchParameter(proj),
		/**
		 * code which should be executed after successfull fetch
		 */
		successFunction: function(){},
		/**
		 * AJAX error handler
		 */
		errorFunction: ajaxError,
		completeFunction:function(){
			$('#warningsLoading').hide();
			gotWarnings=true;
			fetching = false;
		}
	};
	
	if (options==undefined){
		options={};
	}
	
	options = $.extend({}, defaultConfig, options);
		
	if (options.clearContainer)
		options.container.WarningObjects={};

	if (options.snapshotParam==''){
		setError("No snapshot is selected (No data in current branch?)");
		return;
	}
	
	//wrapped in a function to put it into setTimeout to make responsive UI
	loader = function(){
	var starttime = new Date().getTime();
	if (!fetchTypesValues(false, currentSvaceProject)){
		$('#warningsLoading').hide();
		return;
	}
	var typetime = new Date().getTime();
	var Warnings = null;

	$.ajax( {
		url:'/history/api?act=get_warnings&snapshot_id=' + options.snapshotParam + options.branchParam + options.projectParam,
		type: 'POST',
		data: svaceWarningsFilters,
		dataType: 'json',
		cache: false,
		async: true,
		success: function (data, textStatus) {
			//data is already json
			if (data.status === "OK") {
				var endtime = new Date().getTime();
				Warnings = data.warnings;
				console.log('Loading time: ' + (endtime-starttime)+"ms total, "+(typetime-starttime)+"ms types \t["+proj.project_name+'] '+((Warnings==null)?'none':Warnings.length));
				if (Warnings!=null) {
					for (var idx=0; idx<Warnings.length; idx++){
						var Warning = Warnings[idx];
						makeWarningSortingData(Warning);
						Warning.project = currentSvaceProject;
					}
					renderWarningGroups(Warnings, options.container.WarningObjects, options.displayWarnings);
				}
				setTimeout(options.successFunction, 1);
			}
			$('#warningsLoadingCounter').text("");
		},
		error: options.errorFunction,
		complete: options.completeFunction,
	});
	};
	setTimeout(loader, 0);
}

function makeWarningSortingData(Warning){
	//we can use either /full/path/to/file.c, file.c:7143, or just 7143. 
	//I do really hope there is no file names with ':' in it.
	//(I do say about _names_, not _paths_ on windows)
	//If there are - good luck, have some mess, lol
	var sortingdata = Warning.location.short_name.split(":")[0];
	//next we must sort by lines. Lexicographically 123<456<7.
	//If you have more than a 10 million line source file,
	//bad warning sorting is one of your smallest problems.
	sortingdata+=Array(8-Warning.location.line.toString().length).join("0")+Warning.location.line;
	//and finally determined sorting of warnings on the same line:
	sortingdata+=Warning.warning_id;

	//TODO: 'ui_' => 'ui.'
	Warning.ui_sortingdata = sortingdata;
}

function loadTraceData(Warning) {
	var proj = Warning.project;

	var snapshotData ;
	if (Warning.location.snapshot_override == undefined)
		snapshotData = makeSnapshotIDParm(proj);
	else
		snapshotData = Warning.location.snapshot_override;
	
	$.ajax( {
		url:'/history/api?act=get_warning_trace&warning_id='+Warning.warning_id+'&snapshot_id='+snapshotData+getBranchParameter(proj)+getProjectParameter(proj),
		dataType: 'json',
		cache: false,
		success: function (data, textStatus) {
			//data is already json
			if (data.status == "OK") {
				loadTrace(Warning, data.trace);
			}
		},
		error: ajaxError
	});
}

function loadTrace(Warning, trace) {
	var proj = Warning.project;
	var container = document.getElementById(Warning.warning_id+'_trace_data');
	container.innerHTML='';
	inc=0;
	var htmlList = document.createElement('ul');
	htmlList.setAttribute('class', 'WARNING_TRACE');
	container.appendChild(htmlList);
	for (var i=0; i<trace.length; i++) {
		var traceElement = trace[i];
		if (traceElement==null) continue;
		var htmlListItem = document.createElement('li');
		htmlList.appendChild(htmlListItem);
		for (;traceElement!=null;traceElement = traceElement.child) {
			var refElem;
			if (traceElement.location.hash !== null){
				refElem = document.createElement('a');
				htmlListItem.appendChild(refElem);
				htmlListItem.appendChild(document.createElement('br'));
				var id = 'trace_'+Warning.warning_id+'_'+inc++;
				refElem.setAttribute('id', id);
				refElem.setAttribute('href', 'javascript:;');
				$('#'+id).click([traceElement], function(data) {
					loadSource(data.data[0].location, getProjectParameter(proj), makeSnapshotIDParm(proj));
				});
				refElem.innerHTML = escapeHTML(traceElement.message);
			} else {
				refElem = document.createElement('div');
//				refElem.setAttribute('style', 'display: inline;');
				refElem.innerHTML = escapeHTML(traceElement.message+' [No source]');
				htmlListItem.appendChild(refElem);
			}
		}
	}
}

function fetchUpdatesImpl(projectToFetch){
	if (true === projectToFetch.is_fetching_updates)
		return;
	projectToFetch.is_fetching_updates = true;
	myout("Fetching warning updates for project " + projectToFetch.project_name + " [id="+projectToFetch.project_id+"]");
	var Updates;
	$.ajax( {
		url:'/history/api?act=refresh_warnings'+getBranchParameter(projectToFetch)+getProjectParameter(projectToFetch),
		dataType: 'json',
		cache: false,
		success: function (data, textStatus) {
			//data is already json
			if (data.status === "OK") {
				OK = true;
				Updates = data.updates;
				if (Updates !== null) {
					for (var i = 0; i < Updates.length; i++) {
						var dirtyWarningWindow = false;
						Update = Updates[i];

						warning=WarningObjectsWrap.WarningObjects[Update.warning_id];
						if (warning === undefined) {
							// An update might concern warnings that are not
							// currently loaded; these should be skipped
							continue;
						}

						if ((Update.attributes.classification_id !== null)&&(Update.attributes.classification_id !== undefined)) {
							warning.attributes.classification_id = Update.attributes.classification_id;
							dirtyWarningWindow = true;
						}
						if ((Update.attributes.severity_id !== null)&&(Update.attributes.severity_id !== undefined)) {
							warning.attributes.severity_id = Update.attributes.severity_id;
							dirtyWarningWindow = true;
						}
						if ((Update.attributes.action_id !== null)&&(Update.attributes.action_id !== undefined)) {
							warning.attributes.action_id = Update.attributes.action_id;
							dirtyWarningWindow = true;
						}
						if ((Update.attributes.comment !== null)&&(Update.attributes.comment !== undefined)) {
							warning.attributes.comment = Update.attributes.comment;
							dirtyWarningWindow = true;
						}
						if ((Update.attributes.user_attributes !== null)&&(Update.attributes.user_attributes !== undefined)) {
						    for (var attrName in Update.attributes.user_attributes) {
							    if (Update.attributes.user_attributes.hasOwnProperty(attrName)){
							        warning.attributes.user_attributes[attrName] = Update.attributes.user_attributes[attrName];
							    }
						    }
							dirtyWarningWindow = true;
						}
						if (Update.new_reviewers!=undefined){
							for (var k=0; k<Update.new_reviewers.length; k++) {
						        warning.reviewers.push(Update.new_reviewers[k]);
						    }
						}
						if (Update.removed_reviewers!=undefined){
							for (var k=0; k<Update.removed_reviewers.length; k++) {
								//no 'remove'. sigh.
								idx = warning.reviewers.indexOf(Update.removed_reviewers[k]);
								if (idx>-1)
									warning.reviewers.splice(idx,1);
						    }
						}
						var isCurrentWarning = (currentWarning !== null)&&(currentWarning.warning_id === Update.warning_id);
						

						warningEntry = document.getElementById("Warning_"+Update.warning_id);

						if (warningEntry !== null) {
							entryclass = "WARNING_CONTAINER";
							entryclass += " classification_"+warning.attributes.classification_id;
							entryclass += " severity_"+warning.attributes.severity_id;
							if (warning.attributes.comment !== ""){
								entryclass += " commented";
							}
							if (isCurrentWarning){
								entryclass+= " WARNING_CONTAINER_SELECTED"
							}
							
							warningEntry.setAttribute('class', entryclass);
							fillWarningReviewers(warning.reviewers, $('#'+warning.warning_id+"_reviewers"));
						}
						
						if (isCurrentWarning&&dirtyWarningWindow) {
							var Data = new Object();
							Data.data = new Array();
							Data.data[0]=currentWarning.warning_id;
							displayWarning(Data, WarningObjectsWrap.WarningObjects);
						}
						//$('#Warning_'+Warning.warning_id).click([Warning],displayWarning);
					}
				}
			}
		},
		error: function(data, textstatus, error){
			ajaxError(data, textstatus, error);
		}, 
		complete: function(){
			projectToFetch.is_fetching_updates = false;
		}
	});
}

var dirtyClassification=false;
var dirtySeverity=false;
var dirtyAction=false;
var dirtyComment = false;
var dirtyOwner=false;

function displayWarningByIDAndClass(warning_id, clazz){
	if (COMPARE_MODE){
		//TODO: just disable such links for compare mode. just display their text.
		alert("Not implemented yet for compare mode");
		return;
	}
	if ($('#'+getWarningGroupBox(clazz).id).is(":hidden")){
	//	click group header to load it and show it
		$('#'+getWarningGroupBox(clazz).id+'_header').click();
	}
	var Data = new Object();
	Data.data = new Array();
	Data.data[0]=warning_id;
	displayWarning(Data, WarningObjectsWrap.WarningObjects);
	//calling only second scrolltop leads to some... interesting effects. first one fixes em.
	$("#warningsList").scrollTop(0);
	$("#warningsList").scrollTop($("#Warning_"+warning_id).position().top-$("#warningsList").height()/2);
}

var currentWarning=null;
/*
 * Display menu for new current warning (Warnings.data[0])
 * and push data for previous showed warnings
 */
function displayWarning(Warnings, lWarningObjects) {
	pushCardChanges();
	$(".WARNING_CONTAINER_SELECTED").removeClass("WARNING_CONTAINER_SELECTED");
	$("#usagesForm").dialog("close");
	if (Warnings==null) {
		$('#warningCardHide').show();
		return;
	}
	$('#warningCardHide').hide();
	WarningID = Warnings.data[0];
	$('#Warning_'+WarningID).addClass("WARNING_CONTAINER_SELECTED");

	Warning=WarningObjectsWrap.WarningObjects[WarningID];
	var proj = Warning.project;

	dirtyClassification=false;
	dirtySeverity=false;
	dirtyAction = false;
	dirtyComment = false;
	dirtyOwner = false;
	currentWarning=Warning;

	$('#WarnClassification').unbind();
	$('#WarnSeverity').unbind();
	$('#WarnAction').unbind();
	$('#WarnComment').unbind();
	$('#WarnOwner').unbind();

	$('#WarnID').text(Warning.warning_id.substring(0,6)+"...");
	var title = Warning.warning_id;
	var message = Warning.message;
	if(Warning.renamedPreviousVersion != undefined)
	{
        title += "[renamed " + warning.renamedPreviousVersion.warning_id + "]";
        message += "[was " + warning.renamedPreviousVersion.message + "]";
	}
	$('#WarnID').attr("title", title);
	$('#WarnProjectName').text(Warning.project.project_name);
	$('#WarnMessage').text(message);
	$('#WarnLoc').text(Warning.location.short_name+((Warning.location.hash === null)?' [No source]':''));
	$('#WarnLoc').attr('title', Warning.location.file_path);
	$('#WarnLocFull').text(Warning.location.file_path);
	$('#WarnHistory').unbind();
	$('#WarnHistory').click(function() {
		$('#historyEntries').dialog("open");
		loadHistory(Warning);
		return false;
	});
	$('#WarnLoc').unbind();
	$('#WarnLoc').click(function() {
		if (Warning.location.hash !== null){
			loadSource(Warning.location, getProjectParameter(proj), makeSnapshotIDParm(proj));
		}
		return false;
	});

	$('#WarnClassification option[value=\''+Warning.attributes.classification_id+'\']').prop("selected","selected");
	$('#WarnClassification').change(function() {
		dirtyClassification=true;
	});
	
	$('#WarnSeverity option[value=\''+Warning.attributes.severity_id+'\']').prop("selected","selected");
	$('#WarnSeverity').change(function() {
		dirtySeverity=true;
	});
	
	$('#WarnAction option[value=\''+Warning.attributes.action_id+'\']').prop("selected","selected");
	$('#WarnAction').change(function() {
		dirtyAction=true;
	});
	
	$('#WarnTS').text(svace_TS[Warning.attributes.triaged_status_id].name);
	
	$('#WarnComment').val(Warning.attributes.comment);
	$('#WarnComment').change(function() {
		dirtyComment=true;
	});

	$('#WarnOwner').val(Warning.attributes.user_attributes.user_owner);
	$('#WarnOwner').change(function() {
		dirtyOwner=true;
	});

	//since our interface only supports reviewing one warning
	//even if multiple projects are loaded,
	//we must explicitly tell history server that we ended our previous review
	var data = new Object();
	data.warning_id = currentWarning.warning_id;
	$.ajax({
		url : '/history/api?act=start_review&stop_old_reviews=true&'
				+ getBranchParameter(proj)
				+ getProjectParameter(proj),
		type : 'POST',
		dataType : 'json',
		data : data,
		cache : false,
		success : function(data, textStatus) {
			updateWarnings();
		},
		error : ajaxError
	});
}

function pushCardChanges() {
	var data = new Object();
	var ownerData = new Object();

	if (dirtyClassification)
		data.classification_id=$('#WarnClassification').val();
	if (dirtyAction)
		data.action_id=$('#WarnAction').val();
	if (dirtySeverity)
		data.severity_id=$('#WarnSeverity').val();
	if (dirtyComment)
		data.comment=$('#WarnComment').val();
	if (dirtyOwner)
		ownerData.user_owner = $('#WarnOwner').val(); 

	if (dirtyClassification||dirtyAction||dirtySeverity||dirtyComment){
		dirtyClassification = false;
		dirtyAction = false;
		dirtySeverity = false;
		dirtyComment = false;

		$.ajax({
			url : '/history/api?act=put_review&warning_id='
					+ currentWarning.warning_id + getBranchParameter(currentWarning.project)
					+ getProjectParameter(currentWarning.project),
			type : 'POST',
			data : data,
			dataType : 'json',
			cache : false,
			success : function(data, textStatus) {
				// data is already json
				if (data.status == "OK") {
					OK = true;
					updateWarnings();
				}
			},
			error : ajaxError
		});
	}
	
	if (dirtyOwner){
		dirtyOwner = false;

		$.ajax({
			url : '/history/api?act=put_attribute&warning_id='
					+ currentWarning.warning_id + getBranchParameter(currentWarning.project)
					+ getProjectParameter(currentWarning.project),
			type : 'POST',
			data : ownerData,
			dataType : 'json',
			cache : false,
			success : function(data, textStatus) {
				// data is already json
				if (data.status == "OK") {
					OK = true;
					updateWarnings();
				}
			},
			error : ajaxError
		});
	}
}

function loadHistory(Warning) {
	$('#historyEntries').dialog("option", "title", "Loading history...");
	$('#historyEntries').html("");

	var proj = Warning.project;

	$.ajax( {
		url:'/history/api?act=get_all_reviews&warning_id='+Warning.warning_id+getBranchParameter(proj)+getProjectParameter(proj),
		dataType: 'json',
		cache: false,
		success: function (data, textStatus) {
			//data is already json
			if (data.status == "OK") {
				OK = true;
				History = data.reviews;
				var html = "";
				if (History!=null) {
					var odd = false;
					for (var i = 0; i < History.length; i++) {
						odd=!odd;
						Review = History[i];
						event = Review.event;
						if (event!="")
							event = escapeHTML(event);
						if (Review.attributes.classification_id!=undefined){
							if (event!="")
								event+="<br/>";
							event+="Classification was set to &lt;"+svace_classification[Review.attributes.classification_id]+"&gt;";
						}
						if (Review.attributes.severity_id!=undefined){
							if (event!="")
								event+="<br/>";
							event+="Severity was set to &lt;"+svace_severity[Review.attributes.severity_id]+"&gt;";
						}
						if (Review.attributes.action_id!=undefined){
							if (event!="")
								event+="<br/>";
							event+="Action was set to &lt;"+svace_action[Review.attributes.action_id]+"&gt;";
						}
						if (Review.attributes.comment!=undefined){
							if (event!="")
								event+="<br/>";
							event+="Comment was set to &lt;"+escapeHTML(Review.attributes.comment)+"&gt;";
						}
						if (Review.attributes.user_attributes!=undefined){
							if (event!="")
								event+="<br/>";
							attributes = Review.attributes.user_attributes;
							for (var attribute in attributes) {
							    if (attributes.hasOwnProperty(attribute)) {
							        event+="&lt;"+escapeHTML(attribute)+"&gt; set to &lt;"+escapeHTML(attributes[attribute])+"&gt;<br/>";
							    }
							}
						}
						html+="<tr"+(odd?" style=\"background:#bbbbbb\"":" style=\"background:#dddddd\"")+" id=\""+Review.review_id+"\"><td>"+event+"</td><td>"+escapeHTML(Review.reviewer_name)+"</td><td>"+escapeHTML(Review.review_time)+"</td></tr>\n";
					}
				}
				var tableHTML = "<tr id='historyHeader'><td>Event</td><td>Author</td><td>Date</td></tr>"+html+"";
				//"<tr style='height: 100%'><td></td><td></td><td></td></tr>";
				$('#historyEntries').html(tableHTML);
				$('#historyEntries').dialog("option", "title", "Warning history");
				$("#historyEntries").dialog({position:{'my':'center', 'at':'center', 'of': window}});
			}
		},
		error: ajaxError
	});
}

function exportSVRES(){
	var proj = currentSvaceProject;
	window.location.href='/history/api?act=get_warnings&format=svres'+getBranchParameter(proj)+getProjectParameter(proj)+'&snapshot_id='+makeSnapshotIDParm(proj);
}

function importSVRESShow(){
	$('#uploadSVRES').trigger('reset');
	$('#uploadSVRESForm').dialog('open');
}

function importSVRESStart(){
	var file = $("#uploadSVRESFile").val();
	if (!file.match(/\.svres$/)){
		alert("Cannot accept non-svres files!");
		return;
	};
	var form = document.getElementById("uploadSVRES");
	var data = new FormData(form);
	var popup = $("<div/>");
	popup.text("Import in progress...");
	popup.dialog({
		dialogClass : "no-close",
		modal : true,
		resizable : false,
		autoOpen : false,
		closeOnEscape : false,
		draggable : false,
		height : 'auto',
		width : 'auto'
	});
	popup.dialog('open');
	$.ajax( {
		url:'/history/api?act=upload_svres'+getBranchParameter(currentSvaceProject)+getProjectParameter(currentSvaceProject)+'&snapshot_id='+makeSnapshotIDParm(currentSvaceProject),
		type: 'POST',
		data: data,
	    contentType: false,
	    processData: false,		
		cache: false,
        xhr: function() {  // custom xhr
            myXhr = $.ajaxSettings.xhr();
            if(myXhr.upload){ // check if upload property exists
                myXhr.upload.addEventListener('progress',function (evt) {
                    popup.text('updateProgress');
                    if (evt.lengthComputable) {
                    	var percentComplete = Math.round(evt.loaded*100 / evt.total);
                    	if (percentComplete>=99){
                    		popup.text("Upload complete; import in progress; please wait...");
                    	}else{
                        	popup.text("Upload: "+percentComplete+"%");
                    	}
                    }
                }, false); // for handling the progress of the upload
            }
            return myXhr;
        },
		success: function (data, textStatus) {
			popup.dialog('close');
			alert("SVRES import complete. Re-open the project to get new results");
		},
		error: function (data, textstatus, error) {
			popup.dialog('close');
			ajaxError(data, textstatus, error);
			alert("SVRES import FAILED");
		}
	});
}

function isValidHotkey(){
	//no warning is selected => false alarm
	if (currentWarning==null){
		return false;
	}
	
	//active element is textbox => false alarm
	var tagName = document.activeElement.tagName.toLowerCase();
	if ((tagName=='input')||(tagName=='textarea')){
		return false;
	}
	return true;
}

function quickMarkCurrentWarning(isTruePositive){
	if (!isValidHotkey())
		return;
	var id = isTruePositive?1:3;//MAGIC!
	$('#WarnClassification option[value=\''+id+'\']').prop("selected","selected");
	$('#WarnClassification').change();
};

function resortCheckerGroups(){
	var asarray=[];
	for (checker_id in DisplayedWarningsCheckersData) {
		if (DisplayedWarningsCheckersData.hasOwnProperty(checker_id)) {
			asarray.push(DisplayedWarningsCheckersData[checker_id]);
		}
	}
	if (asarray.length>0){
		var comparator;
		var element = asarray[0];
		element = element[CHECKER_SORT];//some problems in ff...
		element = typeof element
		if (element=='string'){
			comparator = function(a,b){
				return a[CHECKER_SORT].localeCompare(b[CHECKER_SORT]);
			}
		} else {
			comparator = function(a,b){
				return -(a[CHECKER_SORT]-b[CHECKER_SORT]);//reverse sort.
			}
		}
		asarray = asarray.sort(comparator);
	}
	var arrayLength = asarray.length;
	var list = $('#warningList');
	for (var i = 0; i < arrayLength; i++) {
		var checkerData = document.getElementById("LIST_"+asarray[i]._id+"_container");
//			alert(asarray[i].name);
		if (checkerData!=undefined){ //it happens
			checkerData.parentNode.appendChild(checkerData);
		}
	}
}

function addDisplayWIDsListener(element, classcollection, warningsToShow){
	element.bind('contextmenu',function(e){
		e.preventDefault();
		var message="";
		if (classcollection!=null){
			for (var idx=0; idx<classcollection.length; idx++){
				if (warningsToShow == undefined || (classcollection[idx].warning_id in warningsToShow))
					message+=classcollection[idx].warning_id+"\n"
			}
		}
		var dialog = $("<div/>");
		var dialogContent = $("<textarea rows=5 cols=60 readonly />");
		dialogContent.text(message);
		dialog.append(dialogContent);
		dialog.dialog({
			title : "Warning IDs",
			resizable : true,
			closeOnEscape : true,
			draggable : true,
			height : 'auto',
			width : 'auto',
			close : function(event, ui) {
				dialog.remove();
			},			
		});
	});
}
