function showManagementDialog(){
	if ($("#managementFormTabs").tabs( "option", "active")==0)
		managerRefreshProjects();
	else
		$("#managementFormTabs").tabs( "option", "active", 0 );
	$("#managementForm").dialog("open");
}

function managerStatus(text){
	$("#managerStatus").text(text);
}

function centerManagement(){
	$("#managementForm").dialog({position:{'my':'center', 'at':'center', 'of': window}});
}

function activeUsersShow(){
	$.ajax({
		url : '/history/api?act=get_active_user_list',
		dataType : 'json',
		type : 'GET',
		async : false,
		cache : false,
		success : function(data, textStatus) {
			// data is already json
			if (data.status != "OK") {
				setError("Error:" + data.error);
			} else {
				var message = "";
				data.users.sort(function(a,b){
					return a.inactive_for-b.inactive_for;
				});
				data.users.forEach(function(user){
					message+=user.user_name+" (";
					if (user.session_number>1){
						message+=user.session_number+" sessions, ";
					}
					var inactive_for;
					if (user.inactive_for>3600){
						inactive_for = Math.round(user.inactive_for/3600)+" hrs";
					} else if (user.inactive_for>60){
						inactive_for = Math.round(user.inactive_for/60)+" min";
					} else {
						inactive_for = user.inactive_for+" sec";
					}
					message+="last activity "+inactive_for+" ago)\n"
				});
				alert(message);
			}
		},
		error : ajaxError
	});
}

function serverShutdown(isRestart){
	if (prompt("Enter 'really' if you really want to "+(isRestart?"restart":"shutdown")+" server!")!="really"){
		setError("Shutdown/restart cancelled!");
		return;
	}
	$.ajax({
		url : '/history/api?act=shutdown',
		dataType : 'json',
		type : 'POST',
		async : false,
		cache : false,
		data : {restart: isRestart},
		success : function(data, textStatus) {
			// data is already json
			if (data.status != "OK") {
				setError("Error:" + data.error);
			} else {
				setError("Looks OK, refreshing page in 5 sec...");
				setTimeout(function(){location.reload();}, 5000);
			}
		},
		error : ajaxError
	});
}

function serverDropCache() {
	$.ajax({
		url : '/history/api?act=dropcache',
		dataType : 'json',
		type : 'POST',
		async : false,
		cache : false,
		data : {arg: 'var'},
		success : function(data, textStatus) {
			// data is already json
			if (data.status != "OK") {
				setError("Error:" + data.error);
			} else {
				setError("Looks OK, refreshing page...");
				location.reload();
			}
		},
		error : ajaxError
	});
}

