function managerRefreshRoles(){
	$("#rolePermissionSelector").html("");
	managerRefreshRolesEx($("#roleSelector"), undefined, true);
}

function managerRefreshRolesEx(list, userID, showManagementOptions){
	list.html("Loading role list...");
	roles = loadRoles(userID);
	if (roles!=null)
		managerDisplayRoles(roles, list, userID, showManagementOptions);
	else
		list.text("Failed to load roles list");
	centerManagement();
}

function loadRoles(userID){
	var loadedRoles = null;
	$.ajax({
		url : '/history/api?act=get_role_list'+((userID==undefined)?'':'&user='+userID),
		dataType : 'json',
		type : 'GET',
		async : false,
		cache : false,
		success : function(data, textStatus) {
			// data is already json
			if (data.status != "OK") {
				setError("Error:" + data.error);
				$("#managerStatus").text(
						"Failed to load role list: " + data.error);
			} else {
				OK = true;
				loadedRoles = data.roles;
				$("#managementForm").dialog({position:{'my':'center', 'at':'center', 'of': window}});
			}
		},
		error : ajaxError
	});
	return loadedRoles;
}

svaceRoles = [];
function managerDisplayRoles(roles, list, userID, showManagementOptions) {
	svaceRoles = roles;
	list.html("");
	if (roles.length > 0) {
		for (var i = 0; i < roles.length; i++) {
			role = roles[i];
			description=role.role_description
			if (description=="")
				description="";
			
			roleLink = "";
			
			if (showManagementOptions)
				roleLink+="<a href='javascript:loadRolePermissions(" + role.role_id + ");' id='Role_"+role.role_id+"'>";
			roleLink+= escapeHTML(role.role_name);
			if (showManagementOptions)
				roleLink += "</a>";
			
			roleLink += "<br/><font size=-2>"+escapeHTML(description);
			
			if (showManagementOptions) {
				roleLink+="<a href='javascript:deleteRole("+i+");'>[delete]</a>";
			}
			if (userID != undefined){
				roleLink+="<a href='javascript:deleteUserRole("+userID+","+role.role_id+");'>[revoke]</a>";
			}
			roleLink += "</font><br/>";
			list.append(roleLink);
		}
	} else {
		list.text("No roles found on server"+((userID==null)?"":" for this user"));//
	}
}

function addRoleShow(){
	$("#newRoleName").val("");
	$("#newRoleDesc").val("");
	$("#addRoleLink").hide();
	$("#roleForm").show();
}

function addRoleSubmit(){
	managerStatus("");
	data = new Object();
	data.name = $("#newRoleName").val();
	data.desc = $("#newRoleDesc").val();
	$.ajax({
		url : '/history/api?act=create_role',
		dataType : 'json',
		type : 'POST',
		data : data,
		async : false,
		cache : false,
		success : function(data, textStatus) {
			// data is already json
			if (data.status != "OK") {
				setError("Error:" + data.error);
				$("#managerStatus").text("Failed to create role: " + data.error);
			} else {
				OK = true;
				managerStatus("Role created");
			}
		},
		error : ajaxError
	});
	$("#addRoleLink").show();
	$("#roleForm").hide();
	managerRefreshRoles();
}

function deleteRole(idx){
	managerStatus("");
	deletedRole = svaceRoles[idx];
	data = new Object();
	data.role_id = deletedRole.role_id;
	$.ajax({
		url : '/history/api?act=delete_role',
		dataType : 'json',
		type : 'POST',
		data : data,
		async : false,
		cache : false,
		success : function(data, textStatus) {
			// data is already json
			if (data.status != "OK") {
				setError("Error:" + data.error);
				managerStatus("Failed to delete role: " + data.error);
			} else {
				OK = true;
				managerStatus("Role deleted");
			}
		},
		error : ajaxError
	});
	managerRefreshRoles();
}

function deleteUserRole(userID, role_id){
	managerStatus("");
	data = new Object();
	data.user_id = userID
	data.role_id = role_id;
	$.ajax({
		url : '/history/api?act=remove_user_role',
		dataType : 'json',
		type : 'POST',
		data : data,
		async : false,
		cache : false,
		success : function(data, textStatus) {
			// data is already json
			if (data.status != "OK") {
				setError("Error:" + data.error);
				managerStatus("Failed to revoke role: " + data.error);
			} else {
				OK = true;
				managerStatus("Role revoked");
			}
		},
		error : ajaxError
	});
	loadUserRoles(userID);
}

function addUserRole(userID, role_id){
	managerStatus("");
	data = new Object();
	data.user_id = userID
	data.role_id = role_id;
	$.ajax({
		url : '/history/api?act=add_user_role',
		dataType : 'json',
		type : 'POST',
		data : data,
		async : false,
		cache : false,
		success : function(data, textStatus) {
			// data is already json
			if (data.status != "OK") {
				setError("Error:" + data.error);
				managerStatus("Failed to grant role: " + data.error);
			} else {
				OK = true;
				managerStatus("Role granted");
			}
		},
		error : ajaxError
	});
}

function addUserRoleDialog(userID){
	$('#addUserRoleLink').hide();
	$('#userRoleSpinnerDiv').html("<select id='userRoleSpinner'></spinner><input type='submit' id='userRoleCommit' value='Add role!'>");
	$('#userRoleCommit').click(function(){
		processAddRoleSpinnerValue(userID);
	});
	roles = loadRoles();
	if (roles!=null){
		for (i=0; i<roles.length; i++)
			$('#userRoleSpinner').append($("<option></option>").attr("value", roles[i].role_id).text(roles[i].role_name));
	} else {
		$('#addUserRoleLink').show();
		$('#userRoleSpinnerDiv').text("&nbsp;Failed to load role list");	
	}
}

function processAddRoleSpinnerValue(userID){
	roleID = $('#userRoleSpinner').val();
	addUserRole(userID, roleID);
	$('#userRoleSpinnerDiv').hide();
	$('#addUserRoleLink').show();
	loadUserRoles(userID);
}
