//make cookie expire in 15 years and not at the end of session
$.cookie.defaults={expires:5000};

function showSettingsDialog(){
	$("#settingsForm").dialog("open");
}

var isOldRenderer=null;
var spacesPerTab=null;
function configureRenderer(){
	var value=($('#codeStyle').val()=='old');
	var dirty = false;
	if (value!=isOldRenderer){
		$.cookie("settings.exprender", !value);		
		isOldRenderer=value;
		dirty = true;
	}
	value = $('#codeTabs').val();
	if (value!=spacesPerTab){
		$.cookie("settings.spacetabs", value);		
		spacesPerTab = value;
		dirty = true;
	}
	
	if (dirty){
		loadSource(lastLocation, lastProjectData, lastSnapshotData, true);
	}
}

var COMPARE_MODE=false;
var RECALL_COUNT_PESS=false;
var RECALL_COUNT_SEMI=false;
var RECALL_COUNT_OPTI=false;
function configureMisc(){
	var NEW_COMPARE_MODE=($('#workMode').val()=='comparator');
	var dirty = false;
	var statsDirty = false;
	if (NEW_COMPARE_MODE!=COMPARE_MODE){
		$.cookie("settings.workmode", NEW_COMPARE_MODE);		
		dirty = true;
	}
	
	var COMPARE_PERCENTAGE_CHECKS=$('#compareTruePess').is(':checked')+"|"+
									$('#compareTrueSemi').is(':checked')+"|"+
									$('#compareTrueOpti').is(':checked');
	var OLD_CPC = $.cookie("settings.compare.checkers");
	if (OLD_CPC!=COMPARE_PERCENTAGE_CHECKS){
		$.cookie("settings.compare.checkers", COMPARE_PERCENTAGE_CHECKS);
		if (COMPARE_MODE){
			statsDirty = true;
		}
	}
	
	if (dirty){
		location.reload();
	}

	if (statsDirty){
		initStatsSettings(COMPARE_PERCENTAGE_CHECKS);
		acRecalculateStats();
	}
}


/**
 * ------------INIT------------------
 */

function initSettings(){
	initRendererSettings();
	initMiscSettings();
	initExternalSettings();
}

function initRendererSettings(){
	if ($.cookie('settings.exprender') == 'false') {
		isOldRenderer = true;
		$('#codeStyle').val('old');
	} else {
		isOldRenderer = false;
		$('#codeStyle').val('new');
	}

	spacesPerTab=$.cookie('settings.spacetabs');
	if ((spacesPerTab === undefined)||(spacesPerTab === null)) {
		spacesPerTab=4;
	}
	if (spacesPerTab !== parseInt(spacesPerTab, 10)){
		spacesPerTab = 4;
	}
	$('#codeTabs').val(spacesPerTab);
}

function initMiscSettings(){
	if ($.cookie('settings.workmode') == 'true') {
		COMPARE_MODE=true;
		$('#workMode').val('comparator');
		$('.hideWhenCompare').hide();
		$('.showWhenCompare').show();
		$('#checkerSortForm').append($("<div><input type='radio' name='checkersort' value='miss_num'>Missing warning number</div>"));
		$('#checkerSortForm').append($("<div><input type='radio' name='checkersort' value='miss_prc'>Missing warning percentage</div>"));
		$('#checkerSortForm').append($("<div><input type='radio' name='checkersort' value='match_num'>Matched warning number</div>"));
		$('#checkerSortForm').append($("<div><input type='radio' name='checkersort' value='match_prc'>Matched warning percentage</div>"));
		$('#checkerSortForm').append($("<div><input type='radio' name='checkersort' value='extra_num'>Extra warning number</div>"));
	} else {
		COMPARE_MODE=false;
		$('#workMode').val('normal');
		$('.hideWhenCompare').show();
		$('.showWhenCompare').hide();
	}
	
	initStatsSettings($.cookie("settings.compare.checkers"));

}

function initStatsSettings(CPC){
	if (CPC==undefined||CPC==null)
		CPC="true|true|false";
	CPC = CPC.split("|");
	if (CPC.length!=3)
		CPC=["true", "true", "false"];
	
	RECALL_COUNT_PESS=(CPC[0]==='true');
	$('#compareTruePess').prop('checked', RECALL_COUNT_PESS);

	RECALL_COUNT_SEMI=(CPC[1]==='true');
	$('#compareTrueSemi').prop('checked', RECALL_COUNT_SEMI);

	RECALL_COUNT_OPTI=(CPC[2]==='true');
	$('#compareTrueOpti').prop('checked', RECALL_COUNT_OPTI);
}

function initExternalSettings(){
	//settings not from 'settings' dialog
	initCheckerSort();
}

var CHECKER_SORT;
function initCheckerSort(){
	CHECKER_SORT = $.cookie('settings.checksort');
	if (CHECKER_SORT == undefined)
		CHECKER_SORT = "name";
	if ((CHECKER_SORT!="name")&&(CHECKER_SORT!="amount")&&!COMPARE_MODE)
		CHECKER_SORT = "name";
	$('input[name=checkersort][value='+CHECKER_SORT+']').prop('checked', true);
}

function applyCheckerSort(){
	CHECKER_SORT = $(this).val();
	$.cookie('settings.checksort', CHECKER_SORT);
    resortCheckerGroups();
}
